function initPullMenuComponent() {
		var _lastPrevNode = $(".sepecial-func-collection");
		var _containerNode = $(".pull-menu-component");
		var _arrow = $(".arrow_set");
		var _touchSensitive = 5;

		var  _container =document.getElementsByClassName('pull-menu-component')[0];
		var _startPosOrigin = 0,
			  _startPosRepos = 0,
	          _currentPos = 0,
	          _lastPos = 0,
	         _moveDist = 0,
	         _touchDist =0;
	          
	   var _responsiveTargetPos =_containerNode.height() - ($(window).height() - (_lastPrevNode.height() + _lastPrevNode.offset().top));
		
		var init = function() {
			clean();
			srollToY(_responsiveTargetPos, false);
			initNativeTouchEvent();
		}
		
		var clean = function() {
			_containerNode.parent().css({
				position: "relative",
				height: $(window).height()
			});
			
			_containerNode.css({
				'position': 'absolute',
			})
			
			/*_containerNode.css({
				'background-color': 'rgba(255,255,255, 0.8)',
				'position': 'absolute',
				'height': '400px',
				'bottom': '0',
				'left': '0',
				'overflow': 'hidden'
			});*/
		}
		
		var setLayer = function() {
			_container.style['z-index'] = 99999;
		}
		
		var resetLayer = function() {
			_container.style['z-index'] = 0;
		}
		
		var srollToY = function(pos, isAnimate) {
			_container.style['transition-property'] = _container.style['-webkit-transition-property'] = "transform";
			_container.style['transition-timing-function'] = _container.style['-webkit-transition-timing-function']  = "cubic-bezier(.2,.79,.34,.95)";
			_container.style['transition-duration'] = _container.style['-webkit-transition-duration'] = isAnimate ? "1000ms" : "0ms";
			_container.style['transform'] = _container.style['-webkit-transform'] =" translate(0px, "+pos+"px) translateZ(0px)";
		}
		
		var initNativeTouchEvent = function() {
			_container.addEventListener('touchstart',function(e){
				e.preventDefault();
				_startPosOrigin = e.targetTouches[0].pageY;
			 	_startPosRepos = _startPosOrigin - Math.abs(getCssTranslateY(_container));
			});
			
			_container.addEventListener('touchmove',function(e){
				e.preventDefault();
				e.stopPropagation();
			 	_currentPos = e.targetTouches[0].pageY;
			 	_moveDist = _currentPos - _startPosRepos;
			 	
			 	if((_moveDist > 0) && (_moveDist < _responsiveTargetPos)) {
			 		srollToY(_moveDist, false); 
			 	}
			 		
			 	//console.log(getCssTranslateY(_container), _moveDist, _responsiveTargetPos);
			});
			
			_container.addEventListener('touchend',function(e){
				e.preventDefault();
			 	_lastPos = e.changedTouches[0].pageY;
			 	_touchDist = _lastPos - _startPosOrigin;
			 	
			 	if(_touchDist != 0) {
			 		if(_touchDist <= -_touchSensitive) { 
				 		srollToY(0, true);
				 		setLayer();
				 	} else if(_touchDist >= _touchSensitive) {
				 		srollToY(_responsiveTargetPos, true);
				 		resetLayer();
				 	}
			 	} else {
			 		if($(e.target).hasClass("arrow_set")) {
				 		goForward();
			 		} 
			 	}
			 	
			 	//console.log(_lastPos - _startPosOrigin, getCssTranslateY(_container));
			});
		}
		
		var goForward = function () {
			if(getCssTranslateY(_container) == 0) {
				srollToY(_responsiveTargetPos, true);
				resetLayer();
			} else {
				srollToY(0, true);
				setLayer();
			}
		}
		
		var getCssTranslateY = function(ele) {
			var numStr = ele.style['transform'].replace(/[^-0-9.]/g,""); 
			numStr = numStr.substring(1, numStr.length-1);
			return parseInt(numStr);
		}
		
		return {
			init: init,
			goForward: goForward
		}
	}