;(function($) {
	$.fn.touchTooltips = function(opt) {
		var defaults = {
			onChange: null
		};
		var config = $.extend({}, defaults, opt || {});
		var selectedContainer = this.find(".current-selected");
		var listContainer = this.find("ul");
		var userEvent = "touchend";
		/*当前项触控区域操作*/
		selectedContainer.unbind(userEvent).bind(userEvent, function(event) {
			event.preventDefault();
			/*整体动画效果*/
			if (listContainer.hasClass("hidden-items")) {
				listContainer.removeClass("hidden-items");
				listContainer.stop(true, true).fadeIn('slow');
			} else {
				listContainer.addClass("hidden-items");
				listContainer.stop(true, true).fadeOut('slow');
			}
			/*数据容器内数据同步*/
			$(this).parent().find("ul li").each(function() {
				if ($(this).html() !== selectedContainer.html()) {
					$(this).removeClass("item-hidden").addClass("item-show");
				} else {
					$(this).removeClass("item-show").addClass("item-hidden");
				}
			});
		});
		/*列表项触控操作*/
		listContainer.find('li').unbind(userEvent).bind(userEvent, function(event) {
			event.preventDefault();
			listContainer.addClass("hidden-items");
			listContainer.stop(true, true).fadeOut('slow');
			selectedContainer.html($(this).html());

			if (typeof(config.onChange == 'function')) {
				config.onChange.call(this, $(this).attr("data-index"), $(this).html());
			}

		});
	}
})(jQuery);